"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NestjsMicroservicePlugin = void 0;
const plugin_framework_1 = require("@protobuf-ts/plugin-framework");
const core_1 = require("./core");
class NestjsMicroservicePlugin extends plugin_framework_1.PluginBase {
    async generate(request) {
        const args = request.parameter?.split(',');
        const servicesFile = args?.find(arg => /services_file=./.test(arg))?.split('=')[1];
        if (!servicesFile) {
            throw new Error('"services_file" parameter must be specified e.g. --ts_proto_opt=services_file=services.json');
        }
        const protosDir = args?.find(arg => /protos_dir=./.test(arg))?.split('=')[1];
        if (!protosDir) {
            throw new Error('"protos_dir" parameter must be specified e.g. --ts_proto_opt=protos_dir=../protos');
        }
        return core_1.generateFiles(request.protoFile, servicesFile, protosDir);
    }
    getSupportedFeatures() {
        return [plugin_framework_1.CodeGeneratorResponse_Feature.PROTO3_OPTIONAL];
    }
}
exports.NestjsMicroservicePlugin = NestjsMicroservicePlugin;
