import { FileDescriptorProto, GeneratedFile, MethodDescriptorProto } from '@protobuf-ts/plugin-framework';
import { Code } from 'ts-poet';
import { Service } from './core';
import { TypeMap } from './types';
export declare function createGeneratedFile(service: Service, fileDescriptorProto: FileDescriptorProto, type: 'types' | 'backend' | 'frontend', codeContent: Code): Promise<GeneratedFile>;
export declare function createGeneratedFileForBackendMicroserviceOptions(service: Service, codeContent: Code): Promise<GeneratedFile>;
export declare function combineCode(acc: Code, cur: Code): Code;
export declare function getMethodDefinition({ name, inputType, outputType }: MethodDescriptorProto, typeMap: TypeMap): Code;
export declare function assertDefined<T>(value: T): asserts value is NonNullable<T>;
